/* Pin configuration:
 * 4 select lines for the 16x1  mux
 * 
 * P1 : P4 (2.1)
 * P2 : P5 (2.2)
 * P3 : P6 (2.3)
 * P4 : P7 (2.4)
 * 2 select line for the 4x1 mux
 * P5 : P8 (4.3)
 * P6 : P10(4.5)
 * 1 line for the mux output: P9 (4.4)*/

#include "msp430x22x4.h"
#include "charlie.h"
#include <stdint.h>

extern int mux_output[];
extern uint8_t msg[];
//unsigned int mux_output[]= {0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
//unsigned int msg[] = {0, 0, 0, 0, 0, 0,
//	                  0, 0, 0};
//
//int mux_output[18] = {1, 1, 1, 1, 1, 1,
//	                  1, 1, 1, 1, 1, 1,
//	                  1, 1, 1, 1, 1, 1};


//
////delay function
//void delay (unsigned int n){
//	int i;
//	for (i=0; i < n; i++) {
//		__no_operation();
//		__no_operation();
//		__no_operation();
//	}
//}


void readMUX(void){
	int i;
	int j;
	int counter;
	int k;
	counter = 0;
	
	P2DIR |= 0x1F; // P2.0 - P2.4 are all output pins;
	P4DIR |= 0x28; // P4.3, P4.5 are output pins 
	P4DIR &= 0xEF; // P4.4 is an input pin

	j = 0x00;

	for (i = 0; i <= 17; i++){
		if ( i == 15 ){
			P2OUT = 0xFF;
			P4OUT = 0x00;  //P5, P6 = 00

		}
		else if (i == 16){
			P2OUT = 0xFF;
			P4OUT = 0x08;	//P5, P6 = 01
			

		}
		else if (i == 17){
			P2OUT = 0xFF;
			P4OUT = 0x20;	//P5, P6 = 10

		}
		else {
		P2OUT = j << 1;
		}
		
	//	delay(1000);
//		for (k = 0 ; k <= 40; k ++){
//			if ((P4IN &0x10) == 0x10){
//				counter++;
//			}
//		}
//		if (counter > (40 - counter)){
//			mux_output[i] = 0;
//		}
//		else{
//			mux_output[i] = 1;
//		}
						
		if (((P4IN & 0x10) == 0x10)){
//			P1DIR |= 0x01;
//			P1OUT ^= 0x01;
//			delay(1000);

			mux_output[i] = 0; //when LED is in light
		}
		else {

			mux_output[i] = 1; //when LED is in shadow
		}

		j = j + 0x01;
	}
	
}



/* this funciton transcribe the status as shown in mux_output to a
 * message for the receiver to light up appropriate LEDs*/
void set_Message(void){  
	int k;

	for (k = 0; k <=17; k ++){
		
			if (k <= 11){
				if (k % 4 == 0){
					if (mux_output[k] == 1){
						msg[(k/4) *2 ] |= 0x03;
						msg[(k/4) *2 + 1] |= 0x03;
					}
					else{
						msg[(k/4) *2 ] &= 0xFC;
						msg[(k/4) *2 + 1] &= 0xFC;
					}
				}
			
				else if (k % 4== 1){
					if (mux_output[k] == 1){
						msg[(k/4)*2] |= 0x0C;
						msg[(k/4)*2+ 1] |= 0x0C;
					}
					else{
						msg[(k/4)*2] &= 0xF3;
						msg[(k/4)*2+ 1] &= 0xF3;
					}
				}
				else if (k % 4 == 2){
					if(mux_output[k] == 1){
						msg[ (k/4) *2] |= 0x30;
						msg[ (k/4) *2+1] |= 0x30;
					}
					else{
						msg[ (k/4) *2] &= 0xCF;
						msg[ (k/4) *2+1] &= 0xCF;	
					}
										
				}
				else {
					if(mux_output[k] == 1){
						msg[(k/4)*2] |= 0xC0;
						msg[(k/4)*2 + 1] |= 0xC0;
					}
					else{
						msg[(k/4)*2] &= 0x3F;
						msg[(k/4)*2 + 1] &= 0x3F;
					}						
				}
			}
			else {
				if (k%2== 0){
					if (mux_output[k] == 1){
						msg[k/2] |= 0xCC;
					}
					else{
						msg[k/2] &= 0x33;
					}
				}
				else {
					if(mux_output[k] == 1){
						msg[k/2] |= 0x33;
					}
					else{
						msg[k/2] &= 0xCC;
					}
				}
			}
		
	}
}

			
			
			
			
		
		
//		
//		if(mux_output[k] == 1 && k%2 == 0){
//			msg[k/2] |=0x0F;
//		}
//		else if (mux_output[k] == 1 && k%2 == 1){
//			msg[k/2] |= 0xF0;
//		}
//		else {}



//void main (void){
//	while(1){
//////		P2DIR |= 0xFF;
//////		P2OUT = 0x04;
////		P4DIR = 0x00;   //output high
////		P4DIR |= 0x08;
////		P4OUT |= 0x08;
////		
////		P4DIR &= 0xEF;  //input
////		if ((P4IN & 0x10) == 0x10){
////			P1DIR |= 0x01;
////			P1OUT |= 0x01;
////		}
//
//
////		P4DIR = 0x00;
////		P4DIR |= 0x04;
////		P4OUT |= 0x04;
//		
//		//P2DIR |= 0xFF;
//		//P2OUT = 0x03;
//		readMUX();
//		set_Message();
////      set_Message();
//	}
//}
